----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:36:20 11/28/2007 
-- Design Name: 
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
    Port ( CLK_in : in  STD_LOGIC;
           RST_in : in  STD_LOGIC;
			  BTN_in	: in	STD_LOGIC;
			  LED_out : out  STD_LOGIC_VECTOR(3 downto 0)
			  );			  
end counter;

architecture Behavioral of counter is
	
	component pulse_gen
		 Generic(
				size : integer := 8
					);	 
		 Port ( CLK_in : in  STD_LOGIC;
				  RST_in : in  STD_LOGIC;
				  VALUE_in : in  STD_LOGIC_VECTOR(size-1 downto 0);
				  SIG_out : out  STD_LOGIC				  	
				);
	end component;

	signal pulse	: STD_LOGIC;
	signal q			: STD_LOGIC_VECTOR(3 downto 0);

begin

	pulse_generator: pulse_gen
	generic map
	(
		size => 26
	)
	port map
	(
			CLK_in	=> CLK_in,
			RST_in	=> RST_in,
			VALUE_in => conv_std_logic_vector(49999999,26),
			SIG_out	=> pulse
	);
	
	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
				q(0)	<= NOT RST_in AND
							(
							(NOT pulse AND 	 q(0)) OR
							(	  pulse AND not q(0))
							);
				
				q(1)	<= NOT RST_in AND
							(
							(NOT pulse AND q(1)) OR
							(    pulse AND 
								(
									(	  BTN_in AND (q(1) XOR 	   q(0))) OR
									(NOT BTN_in AND (q(1) XOR NOT q(0)))
								)
							));
				q(2)	<= NOT RST_in AND
							(
							(NOT pulse AND q(2)) OR
							(    pulse AND 
								(
									(	  BTN_in AND (q(2) XOR 	   (    q(1) AND     q(0)))) OR
									(NOT BTN_in AND (q(2) XOR 		(NOT q(1) AND NOT q(0))))
								)
							));
				q(3)	<= NOT RST_in AND
							(
							((NOT pulse AND q(3)) OR
							(    pulse AND 
								(
									(	  BTN_in AND (q(3) XOR 	   (    q(2) AND	   q(1) AND     q(0)))) OR
									(NOT BTN_in AND (q(3) XOR 		(NOT q(2) AND NOT q(1) AND NOT q(0))))
								)
							)));
		end if;	
	end process;
	
	LED_out	<= q;
	
	

end Behavioral;

