----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:26:45 11/28/2007 
-- Design Name: 
-- Module Name:    pulse_gen - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pulse_gen is
    Generic(
			size : integer := 8
				);	 
	 Port ( CLK_in : in  STD_LOGIC;
           RST_in : in  STD_LOGIC;
           VALUE_in : in  STD_LOGIC_VECTOR(size-1 downto 0);
           SIG_out : out  STD_LOGIC
			);
end pulse_gen;

architecture Behavioral of pulse_gen is
	signal q		 :	STD_LOGIC_VECTOR(size-1 downto 0);
begin

	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				q	<= (others => '0');
			else
				if (q	= VALUE_in) then
					q	<= (others => '0');
				else
					q	<= q + 1;
				end if;
			end if;		
		end if;	
	end process;
	
	SIG_out	<= '1' when	q = VALUE_in else '0';	

end Behavioral;

